//
//  Array2_dbl.cc
//  Definition av tvdimensionell arrayklass, double
//

#include <stdlib.h>
#include "Array2_dbl.h"


Array2_dbl::Array2_dbl()          //  Standardkonstruktor, tom array
 {
   storlek1 = 0;
   storlek2 = 0;
   antal1   = 0;
   antal2   = 0;
   arr      = 0;
 }

Array2_dbl::Array2_dbl( int n1, int n2 )
 {
   int  i, j;

   storlek1 = n1;
   storlek2 = n2;
   antal1   = n1;
   antal2   = n2;
   arr      = new double[n1*n2];
   if ( arr == 0 )
    {
      cerr << "Kan ej konstruera array, lngd " << n1*n2 << endl;
      exit(1);
    }
   else
      for ( i=0; i<n1; i++ )
      for ( j=0; j<n2; j++ )
         arr[i*n2+j] = ODEF;
 }

Array2_dbl::Array2_dbl( const Array2_dbl& hl )    // Copy constructor
 {
   int     i, j;

   arr = new double[hl.storlek1*hl.storlek2];
   if ( arr == 0 )
    {
      cerr << "Copy constructor kan ej erhlla "
           << hl.storlek1*hl.storlek2 << "element" << endl;
      exit(1);
    }
   storlek1 = hl.storlek1;
   storlek2 = hl.storlek2;
   antal1   = hl.antal1;
   antal2   = hl.antal2;
   for ( i=0; i<hl.storlek1; i++ )  // Flytta ver element
   for ( j=0; j<hl.storlek2; j++ )  // Flytta ver element
      arr[i*storlek2+j] = hl.arr[i*storlek2+j];
 }

Array2_dbl::~Array2_dbl()        //  Standarddestruktor
 {
   delete [] arr;
 }

Array2_dbl& Array2_dbl::operator=( const Array2_dbl& hl )
          //   Tilldelningsoperator fr arrayer
 {
   int     i, j;
   double  *temp;

   cout << "Copy arrays" << endl;
   if ( this == &hl )              // Fallet   a = a
      return *this;

   if ( storlek1*storlek2 != hl.storlek1*hl.storlek2 )
    {
      temp = new double[hl.storlek1*hl.storlek2];
      if ( temp == 0 )
       {
         cerr << "Array2_dbl = : kan ej erhlla "
              << hl.storlek1*hl.storlek2 << "element" << endl;
         exit(1);
       }
      storlek1 = hl.storlek1;
      storlek2 = hl.storlek2;
      delete [] arr;
      arr = temp;
    }

   antal1 = hl.antal1;
   antal2 = hl.antal2;
   for ( i=0; i<hl.storlek1; i++ )  // Flytta ver element
   for ( j=0; j<hl.storlek2; j++ )
      arr[i*storlek2+j] = hl.arr[i*storlek2+j];

   return *this;
 }

void Array2_dbl::in( istream& ins )
          //   R inlsning av array
 {
   int  i, j, ant1, ant2;

   ins >> ant1 >> ant2;
   if ( ant1 > storlek1  ||
        ant2 > storlek2     )  // Den fr inte plats, avbryt
    {
      cerr << "Arrayinlsning, kan ej lsa in "
           << ant1 << '*' << ant2 << " element, storleken r "
           << storlek1 << '*' << storlek2 << endl;
      exit(1);
    }
   for ( i=0; i<ant1; i++ )
   for ( j=0; j<ant2; j++ )
      ins >> arr[i*storlek2+j];
   for ( i=ant1; i<storlek1; i++ )
   for ( j=0; j<storlek2; j++ )
      arr[i*storlek2+j] = ODEF;
   for ( i=0; i<ant1; i++ )
   for ( j=ant2; j<storlek2; j++ )
      arr[i*storlek2+j] = ODEF;

   antal1 = ant1;
   antal2 = ant2;
 }

void Array2_dbl::ut( ostream& uts )
          //   R utskrift av array
 {
   int  i, j;

   uts << antal1 << ' ' << antal2 << endl;
   for ( i=0; i<antal1; i++ )
    {
      for ( j=0; j<antal2; j++ )
         uts << ' ' << arr[i*storlek2+j];
      uts << endl;
    }
 }

void Array2_dbl::satt_antal( int nytt_antal1, int nytt_antal2 )
          //   Stt nytt antal
 {
   if ( nytt_antal1 < 0 )
      antal1 = 0;
   else if ( nytt_antal1 > storlek1 )
      antal1 = storlek1;
   else
      antal1 = nytt_antal1;

   if ( nytt_antal2 < 0 )
      antal2 = 0;
   else if ( nytt_antal2 > storlek2 )
      antal2 = storlek2;
   else
      antal2 = nytt_antal2;
 }

/*
double& Array2_dbl::operator()( int index1, int index2 )
          //   Indexoperator
 {
   if ( index1 < 0  ||  index1 >= antal1  ||
        index2 < 0  ||  index2 >= antal2     )
    {
      cerr << "Felaktiga arrayindex "
           << index1 << " , " << index2
           << " , antalen r "
           << antal1 << " , " << antal2 << endl;
      exit(1);
    }

   return arr[index1*storlek2+index2];
 }
 */
